diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 664a29451..b33707119 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -489,21 +489,12 @@ public class WorldRenderer
         int mouseX = (Mouse.getX() * width) / mc.resolution.width;
         int mouseY = height - (Mouse.getY() * height) / mc.resolution.height - 1;
         int c = 200;
-        if(mc.gameSettings.limitFramerate.value == 1) // Balanced
-        {
-            c = 120;
-        }
-        if(mc.gameSettings.limitFramerate.value == 2) // Power saver
-        {
-            c = 40;
-        }
-        if(mc.gameSettings.limitFramerate.value == 3) // VSync
+        if(mc.gameSettings.enableVsync.value) // VSync
         {
             if(mc.gameWindow instanceof GameWindowLWJGL2){
-                c = ((GameWindowLWJGL2) mc.gameWindow).defaultDisplayMode.getFrequency();
+                c = ((GameWindowLWJGL2) mc.gameWindow).defaultDisplayMode.getFrequency() + 20; // Cap fps when minimized
             }
-        }
-        if(mc.gameSettings.limitFramerate.value == 0 && mc.gameSettings.customFpsLimit.value > 0){
+        } else {
             c = mc.gameSettings.customFpsLimit.value;
         }
         GL11.glViewport(0, 0, mc.resolution.width, mc.resolution.height);
@@ -513,7 +504,7 @@ public class WorldRenderer
             mc.render.beginRenderWorld(partialTick);
             
             Debug.change("world");
-            if(mc.gameSettings.limitFramerate.value == 0 && mc.gameSettings.customFpsLimit.value == 0) // Max FPS
+            if(!mc.gameSettings.enableVsync.value && mc.gameSettings.customFpsLimit.value == 0) // Max FPS
             {
                 renderWorld(partialTick, 0);
             }
@@ -522,7 +513,7 @@ public class WorldRenderer
                 renderWorld(partialTick, systemTime + (nsPerSecond / c));
             }
             Debug.change("misc");
-            if(mc.gameSettings.limitFramerate.value != 0 || mc.gameSettings.customFpsLimit.value > 0) // Power saver
+            if(mc.gameSettings.enableVsync.value || mc.gameSettings.customFpsLimit.value > 0) // Power saver
             {
                 Debug.change("sleep");
                 long l1 = ((systemTime + (nsPerSecond / c)) - System.nanoTime()) / 1_000_000;
@@ -553,7 +544,7 @@ public class WorldRenderer
             GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
             GL11.glLoadIdentity();
             setupScaledResolution();
-            if(mc.gameSettings.limitFramerate.value != 0 || mc.gameSettings.customFpsLimit.value > 0)
+            if(mc.gameSettings.enableVsync.value || mc.gameSettings.customFpsLimit.value > 0)
             {
                 Debug.change("sleep");
                 long l2 = ((systemTime + (long)(0x3b9aca00 / c)) - System.nanoTime()) / 0xf4240L;
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index b8cc99440..9ec82367d 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -29,6 +29,7 @@ public final class BlockColorDispatcher
         addDispatch(Block.leavesOak, new BlockColorLeavesOak());
         addDispatch(Block.leavesPine, new BlockColorLeaves("pine"));
         addDispatch(Block.leavesShrub, new BlockColorLeaves("shrub"));
+        addDispatch(Block.leavesCaatinga, new BlockColorLeaves("caatinga"));
         addDispatch(Block.mossStone, new BlockColorGrass());
         addDispatch(Block.mossBasalt, new BlockColorGrass());
         addDispatch(Block.mossLimestone, new BlockColorGrass());
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index f13169366..901165a44 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render.block.color;
 import net.minecraft.core.block.Block;
 import net.minecraft.client.render.colorizer.ColorizerGrass;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
 import org.lwjgl.Sys;
@@ -35,7 +35,25 @@ public class BlockColorTallGrass
         int baseGrassColor = ColorizerGrass.getGrassColor(localTemperature, localHumidity);
         if (world != null)
         {
-        	int blockBelow = world.getBlockId(x, y -1, z);
+            if(world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA){
+
+                Season season = world.seasonManager.getCurrentSeason();
+                if (season != null)
+                {
+                    boolean ishumid = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS || season == Seasons.OVERWORLD_FALL);
+                    float progress = world.seasonManager.getSeasonProgress();
+
+                    if(ishumid){
+                        baseGrassColor = ColorizerGrass.getGrassColor(1.0, 1.0);
+                    } else {
+                        baseGrassColor = ColorizerGrass.getGrassColor(1.0, 0.0);
+                    }
+                    baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.seasonManager.getNextSeason() : world.seasonManager.getPreviousSeason(), Math.abs(progress - 0.5f));
+                }
+                return baseGrassColor;
+            }
+
+        	int blockBelow = world.getBlockId(x, y - 1, z);
             if(blockBelow == Block.grassScorched.id || blockBelow == Block.dirtScorched.id || blockBelow == Block.dirtScorchedRich.id ){
 
                 return 0xffcc58;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
new file mode 100644
index 000000000..9cc068533
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -0,0 +1,112 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockBrazier;
+import net.minecraft.core.block.BlockFire;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.lwjgl.opengl.GL11;
+
+public class BlockModelBrazier<T extends BlockBrazier>
+    extends BlockModelStandard<T> {
+    protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/brazier_side");
+    protected IconCoordinate baseTexture = TextureRegistry.getTexture("minecraft:block/brazier_base");
+    protected BlockModelStandard<Block> fireModel = new BlockModelFire<>(Block.fire, true).withTextures("minecraft:block/fire");
+
+    public BlockModelBrazier(Block block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        tessellator.setColorOpaque_I(0xFFFFFF);
+
+        renderBlocks.enableAO = true;
+        renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
+        renderSide(tessellator, block, x, y, z, Side.NORTH, 0);
+        renderSide(tessellator, block, x, y, z + 1, Side.NORTH, 0);
+        renderSide(tessellator, block, x, y, z, Side.SOUTH, 0);
+        renderSide(tessellator, block, x, y, z - 1, Side.SOUTH, 0);
+        renderSide(tessellator, block, x, y, z, Side.EAST, 0);
+        renderSide(tessellator, block, x - 1, y, z, Side.EAST, 0);
+        renderSide(tessellator, block, x, y, z, Side.WEST, 0);
+        renderSide(tessellator, block, x + 1, y, z, Side.WEST, 0);
+        renderSide(tessellator, block, x, y, z, Side.BOTTOM, 0);
+        renderSide(tessellator, block, x, y - 1, z, Side.TOP, 0);
+        renderBlocks.enableAO = false;
+
+        if (block.isBurning()) {
+            fireModel.render(tessellator, x, y, z);
+        }
+
+        return true;
+    }
+
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+
+        GL11.glColor4f(brightness, brightness, brightness, alpha);
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, -1F, 0.0F);
+        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, baseTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 1.0F, 0.0F);
+        renderTopFace(tessellator, block, 0.0D, -1.0D, 0.0D, baseTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, -1F);
+        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, -1F);
+        renderNorthFace(tessellator, block, 0.0D, 0.0D, 1.0D, sideTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, 1.0F);
+        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, 1.0F);
+        renderSouthFace(tessellator, block, 0.0D, 0.0D, -1.0D, sideTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(-1F, 0.0F, 0.0F);
+        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(-1F, 0.0F, 0.0F);
+        renderWestFace(tessellator, block, 1.0D, 0.0D, 0.0D, sideTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(1.0F, 0.0F, 0.0F);
+        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, sideTexture);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(1.0F, 0.0F, 0.0F);
+        renderEastFace(tessellator, block, -1.0D, 0.0D, 0.0D, sideTexture);
+        tessellator.draw();
+
+        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+    }
+
+    @Override
+    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side) {
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index beedcc733..de5da1b0b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -80,6 +80,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Block.bookshelfPlanksOak).withTextures("minecraft:block/planks_oak", "minecraft:block/bookshelf_side"));
 
         addDispatch(new BlockModelWool<>(Block.wool));
+        addDispatch(new BlockModelRope<>(Block.rope).withTextures("minecraft:block/rope"));
 
         addDispatch(new BlockModelStandard<>(Block.brickClay).withTextures("minecraft:block/brick_clay"));
         addDispatch(new BlockModelStandard<>(Block.brickStonePolished).withTextures("minecraft:block/brick_polished_stone"));
@@ -185,6 +186,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelLeaves<>(Block.leavesShrub, "minecraft:block/leaves_shrub"));
         addDispatch(new BlockModelCherryLeavesBloom<>(Block.leavesCherryFlowering));
         addDispatch(new BlockModelCacaoLeaves<>(Block.leavesCacao));
+        addDispatch(new BlockModelLeaves<>(Block.leavesCaatinga, "minecraft:block/leaves_caatinga"));
 
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingOak).withTextures("minecraft:block/sapling_oak"));
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingOakRetro).withTextures("minecraft:block/sapling_oak_retro"));
@@ -293,6 +295,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorPlanksOak).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/trapdoor_planks_oak_side"));
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorIron).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/trapdoor_iron_side"));
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorGlass).withTextures("minecraft:block/glass", "minecraft:block/trapdoor_glass_side"));
+        addDispatch(new BlockModelTrapDoorPainted<>(Block.trapdoorPlanksOakPainted));
 
         addDispatch(new BlockModelStandard<>(Block.tnt).withTextures("minecraft:block/tnt_top", "minecraft:block/tnt_bottom", "minecraft:block/tnt_side"));
 
@@ -300,14 +303,21 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelDoor<>(Block.doorPlanksOakTop).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/door_planks_oak_top"));
         addDispatch(new BlockModelDoor<>(Block.doorIronBottom).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/door_iron_bottom"));
         addDispatch(new BlockModelDoor<>(Block.doorIronTop).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/door_iron_top"));
+        addDispatch(new BlockModelDoorPainted<>(Block.doorPlanksOakPaintedBottom, false).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/door_planks_oak_bottom"));
+        addDispatch(new BlockModelDoorPainted<>(Block.doorPlanksOakPaintedTop, true).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/door_planks_oak_top"));
+        addDispatch(new BlockModelDoorGlass<>(Block.doorGlassBottom).withTextures("minecraft:block/glass", "minecraft:block/door_glass_bottom"));
+        addDispatch(new BlockModelDoorGlass<>(Block.doorGlassTop).withTextures("minecraft:block/glass", "minecraft:block/door_glass_top"));
 
         addDispatch(new BlockModelTransparent<>(Block.mesh, true).withTextures("minecraft:block/mesh"));
+        addDispatch(new BlockModelTransparent<>(Block.meshGold, true).withTextures("minecraft:block/mesh_gold"));
 
         addDispatch(new BlockModelBed<>(Block.bed));
         addDispatch(new BlockModelSeat<>(Block.seat).withTextures("minecraft:block/seat_top", "minecraft:block/planks_oak", "minecraft:block/seat_side"));
 
         addDispatch(new BlockModelCrossedSquares<>(Block.cobweb).withTextures("minecraft:block/cobweb"));
         addDispatch(new BlockModelFire<>(Block.fire).withTextures("minecraft:block/fire"));
+        addDispatch(new BlockModelBrazier<>(Block.brazierInactive).withTextures("minecraft:block/brazier_base", "minecraft:block/brazier_side"));
+        addDispatch(new BlockModelBrazier<>(Block.brazierActive).withTextures("minecraft:block/brazier_base", "minecraft:block/brazier_side"));
 
         addDispatch(new BlockModelStandard<>(Block.mobspawner).withTextures("minecraft:block/mobspawner"));
         addDispatch(new BlockModelTransparent<>(Block.mobspawnerDeactivated, true).withTextures("minecraft:block/mobspawner"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
new file mode 100644
index 000000000..d52dce33a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
@@ -0,0 +1,15 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.util.helper.Side;
+
+public class BlockModelDoorGlass<T extends BlockDoor> extends BlockModelDoor<T>{
+    public BlockModelDoorGlass(Block block) {
+        super(block);
+    }
+    @Override
+    protected boolean shouldFlipTexture(Side side, int meta){
+        return false;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
new file mode 100644
index 000000000..f2e521150
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
@@ -0,0 +1,37 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.item.ItemDye;
+import net.minecraft.core.util.helper.Side;
+
+public class BlockModelDoorPainted<T extends BlockDoor> extends BlockModelDoor<T> {
+    public static final IconCoordinate[] doorBottomTextures = new IconCoordinate[16];
+    public static final IconCoordinate[] doorTopTextures = new IconCoordinate[16];
+
+    static {
+        for(int i = 0; i < 16; i++) {
+            doorTopTextures[i] = TextureRegistry.getTexture("minecraft:block/door_planks_oak_" + ItemDye.dyeColors[15 - i] + "_top");
+            doorBottomTextures[i] = TextureRegistry.getTexture("minecraft:block/door_planks_oak_" + ItemDye.dyeColors[15 - i] + "_bottom");
+        }
+    }
+    private final boolean isTop;
+    public BlockModelDoorPainted(Block block, boolean isTop) {
+        super(block);
+        this.isTop = isTop;
+    }
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    {
+        int sideId = side.getId();
+        int color = (data >> 4) & 0xF;
+        if (sideId < 2){
+            return BlockModelTrapDoorPainted.topTextures[color];
+        } else if (isTop){
+            return doorTopTextures[color];
+        }
+        return doorBottomTextures[color];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 15bc3f123..4c2a7e16d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -7,8 +7,14 @@ import net.minecraft.core.block.BlockFire;
 import net.minecraft.core.util.helper.Side;
 
 public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
+    private final boolean overrideRender;
     public BlockModelFire(Block block) {
+        this(block, false);
+    }
+
+    public BlockModelFire(Block block, boolean overrideRender) {
         super(block);
+        this.overrideRender = overrideRender;
     }
 
     @Override
@@ -26,7 +32,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
         double vMin = tex.getIconVMin();
         double vMax = tex.getIconVMax();
         final float yOffset = 1.4F;
-        if(renderBlocks.blockAccess.isBlockNormalCube(x, y - 1, z) || ((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x, y - 1, z))
+        if(overrideRender || renderBlocks.blockAccess.isBlockNormalCube(x, y - 1, z) || ((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x, y - 1, z))
         {
             double d8 = (double)x + 0.5D + 0.2D;
             double d9 = ((double)x + 0.5D) - 0.2D;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index 8580d94a6..a39b8256c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -1,13 +1,20 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.WorldSource;
+import org.lwjgl.opengl.GL11;
 
 public class BlockModelLayer<T extends Block> extends BlockModelStandard<T> {
     public BlockModelLayer(Block block) {
         super(block);
         withCustomItemBounds(0.0f, 0.0f, 0.0f, 1.0f, 2 / 16F, 1.0f);
     }
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+        GL11.glTranslatef(0, 0.25f, 0);
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+    }
 
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side, int meta)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
new file mode 100644
index 000000000..a7d363cd2
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -0,0 +1,74 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockRope;
+import net.minecraft.core.world.World;
+
+public class BlockModelRope<T extends BlockRope>
+extends BlockModelStandard<T> {
+    public BlockModelRope(Block block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        World world = renderBlocks.world;
+        boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == block.id;
+        boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == block.id;
+        boolean hasBlockNegY = world.getBlockId(x, y - 1, z) == block.id;
+        boolean hasBlockPosY = world.getBlockId(x, y + 1, z) == block.id || world.isBlockOpaqueCube(x, y + 1, z);
+        boolean hasBlockNegZ = world.getBlockId(x, y, z - 1) == block.id;
+        boolean hasBlockPosZ = world.getBlockId(x, y, z + 1) == block.id;
+
+        boolean drawKnot =  !(hasBlockNegX && hasBlockPosX && !hasBlockNegY && !hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
+            !(!hasBlockNegX && !hasBlockPosX && hasBlockNegY && hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
+            !(!hasBlockNegX && !hasBlockPosX && !hasBlockNegY && !hasBlockPosY && hasBlockNegZ && hasBlockPosZ);
+
+        block.setBlockBounds(0, 0, 0, 1, 1, 1);
+
+        if (drawKnot)
+        {
+            block.setBlockBounds(0.5f - (2 / 16f), 0.5f - (2 / 16f), 0.5f - (2 / 16f), 0.5f + (2 / 16f), 0.5f + (2 / 16f), 0.5f + (2 / 16f));
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+
+        if (hasBlockPosY)
+        {
+            block.setBlockBounds(0.5f - (1 / 16f), 0.5f, 0.5f - (1 / 16f), 0.5f + (1 / 16f), 1, 0.5f + (1 / 16f));
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+        if (hasBlockNegY)
+        {
+            block.setBlockBounds(0.5f - (1 / 16f), 0, 0.5f - (1 / 16f), 0.5f + (1 / 16f), 0.5f, 0.5f + (1 / 16f));
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+        if (hasBlockPosX)
+        {
+            block.setBlockBounds(0.5f, 0.5f - (1 / 16f), 0.5f - (1 / 16f), 1, 0.5f + (1 / 16f), 0.5f + (1 / 16f));
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+        if (hasBlockNegX)
+        {
+            block.setBlockBounds(0, 0.5f - (1 / 16f), 0.5f - (1 / 16f), 0.5f, 0.5f + (1 / 16f), 0.5f + (1 / 16f));
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+        if (hasBlockPosZ)
+        {
+            block.setBlockBounds(0.5f - (1 / 16f), 0.5f - (1 / 16f), 0.5f, 0.5f + (1 / 16f), 0.5f + (1 / 16f), 1);
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+        if (hasBlockNegZ)
+        {
+            block.setBlockBounds(0.5f - (1 / 16f), 0.5f - (1 / 16f), 0f, 0.5f + (1 / 16f), 0.5f + (1 / 16f), 0.5f);
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+
+        block.setBlockBounds(0, 0, 0, 1, 1, 1);
+
+
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
new file mode 100644
index 000000000..f690e2511
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
@@ -0,0 +1,43 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockTrapDoor;
+import net.minecraft.core.item.ItemDye;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.Sides;
+
+public class BlockModelTrapDoorPainted<T extends Block> extends BlockModelTrapDoor<T> {
+    public static final IconCoordinate[] topTextures = new IconCoordinate[16];
+    public static final IconCoordinate[] sideTextures = new IconCoordinate[16];
+
+    static {
+        for(int i = 0; i < 16; i++) {
+            topTextures[i] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + ItemDye.dyeColors[15 - i] + "_top");
+            sideTextures[i] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + ItemDye.dyeColors[15 - i] + "_side");
+        }
+    }
+    public BlockModelTrapDoorPainted(Block block) {
+        super(block);
+    }
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    {
+        int color = (data >> 4) & 0xF;
+        int orientation = data & 3;
+        if(BlockTrapDoor.isTrapdoorOpen(data)) {
+            int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
+            if (index < 2) return topTextures[color];
+            return sideTextures[color];
+        } else {
+            if(side.getAxis() == Axis.Y) {
+                return topTextures[color];
+            }else {
+                return sideTextures[color];
+            }
+        }
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/colorizer/ColorProperties.java b/src/main/java/net/minecraft/client/render/colorizer/ColorProperties.java
index 704ad407c..10a68cb6e 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/ColorProperties.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/ColorProperties.java
@@ -24,6 +24,7 @@ public class ColorProperties
         registerLeavesColor("cherry", prop);
         registerLeavesColor("eucalyptus", prop);
         registerLeavesColor("shrub", prop);
+        registerLeavesColor("caatinga", prop);
         registerLeavesColor("cocoa", prop);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/BobberRenderer.java b/src/main/java/net/minecraft/client/render/entity/BobberRenderer.java
index 864b6ad21..52b258a1b 100644
--- a/src/main/java/net/minecraft/client/render/entity/BobberRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/BobberRenderer.java
@@ -49,29 +49,29 @@ public class BobberRenderer extends EntityRenderer<EntityBobber>
         tessellator.draw();
         GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
         GL11.glPopMatrix();
-        if(entity.angler != null)
+        if(entity.player != null)
         {
-            float f9 = ((entity.angler.yRotO + (entity.angler.yRot - entity.angler.yRotO) * f1) * MathHelper.PI) / 180F;
+            float f9 = ((entity.player.yRotO + (entity.player.yRot - entity.player.yRotO) * f1) * MathHelper.PI) / 180F;
             double d3 = MathHelper.sin(f9);
             double d5 = MathHelper.cos(f9);
-            float f11 = entity.angler.getSwingProgress(f1);
+            float f11 = entity.player.getSwingProgress(f1);
             float f12 = MathHelper.sin(MathHelper.sqrt_float(f11) * MathHelper.PI);
             Vec3d vec3d = Vec3d.createVector(-0.5D, 0.03D, 0.8D);
-            vec3d.rotateAroundX((-(entity.angler.xRotO + (entity.angler.xRot - entity.angler.xRotO) * f1) * MathHelper.PI) / 180F);
-            vec3d.rotateAroundY((-(entity.angler.yRotO + (entity.angler.yRot - entity.angler.yRotO) * f1) * MathHelper.PI) / 180F);
+            vec3d.rotateAroundX((-(entity.player.xRotO + (entity.player.xRot - entity.player.xRotO) * f1) * MathHelper.PI) / 180F);
+            vec3d.rotateAroundY((-(entity.player.yRotO + (entity.player.yRot - entity.player.yRotO) * f1) * MathHelper.PI) / 180F);
             vec3d.rotateAroundY(f12 * 0.5F);
             vec3d.rotateAroundX(-f12 * 0.7F);
-            double d7 = entity.angler.xo + (entity.angler.x - entity.angler.xo) * (double)f1 + vec3d.xCoord;
-            double d8 = entity.angler.yo + (entity.angler.y - entity.angler.yo) * (double)f1 + vec3d.yCoord;
-            double d9 = entity.angler.zo + (entity.angler.z - entity.angler.zo) * (double)f1 + vec3d.zCoord;
+            double d7 = entity.player.xo + (entity.player.x - entity.player.xo) * (double)f1 + vec3d.xCoord;
+            double d8 = entity.player.yo + (entity.player.y - entity.player.yo) * (double)f1 + vec3d.yCoord;
+            double d9 = entity.player.zo + (entity.player.z - entity.player.zo) * (double)f1 + vec3d.zCoord;
             if(renderDispatcher.gameSettings.thirdPersonView.value > 0)
             {
-                float f10 = ((entity.angler.prevRenderYawOffset + (entity.angler.renderYawOffset - entity.angler.prevRenderYawOffset) * f1) * MathHelper.PI) / 180F;
+                float f10 = ((entity.player.prevRenderYawOffset + (entity.player.renderYawOffset - entity.player.prevRenderYawOffset) * f1) * MathHelper.PI) / 180F;
                 double d4 = MathHelper.sin(f10);
                 double d6 = MathHelper.cos(f10);
-                d7 = (entity.angler.xo + (entity.angler.x - entity.angler.xo) * (double)f1) - d6 * 0.35D - d4 * 0.85D;
-                d8 = (entity.angler.yo + (entity.angler.y - entity.angler.yo) * (double)f1) - 0.45D;
-                d9 = ((entity.angler.zo + (entity.angler.z - entity.angler.zo) * (double)f1) - d4 * 0.35D) + d6 * 0.85D;
+                d7 = (entity.player.xo + (entity.player.x - entity.player.xo) * (double)f1) - d6 * 0.35D - d4 * 0.85D;
+                d8 = (entity.player.yo + (entity.player.y - entity.player.yo) * (double)f1) - 0.45D;
+                d9 = ((entity.player.zo + (entity.player.z - entity.player.zo) * (double)f1) - d4 * 0.35D) + d6 * 0.85D;
             }
             double d10 = entity.xo + (entity.x - entity.xo) * (double)f1;
             double d11 = entity.yo + (entity.y - entity.yo) * (double)f1 + 0.25D;
